"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_form_renderer_1 = require("@data-driven-forms/react-form-renderer");
var evergreen_ui_1 = require("evergreen-ui");
var field_array_1 = __importDefault(require("@data-driven-forms/react-form-renderer/field-array"));
;
var FieldArrayItem = function (_a) {
    var name = _a.name, fields = _a.fields, length = _a.length, minItems = _a.minItems, remove = _a.remove;
    var renderForm = (0, react_form_renderer_1.useFormApi)().renderForm;
    var editedFields = fields.map(function (field, index) {
        var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
        return __assign(__assign({}, field), { name: computedName, key: "".concat(name, "-").concat(index) });
    });
    var isRemoveDisabled = length <= minItems;
    return react_1.default.createElement(evergreen_ui_1.Pane, { display: "flex", flexDirection: "column", border: true, marginBottom: 4, padding: 4 },
        editedFields.map(function (field) { return renderForm([field]); }),
        react_1.default.createElement(evergreen_ui_1.Button, { size: "small", disabled: isRemoveDisabled, onClick: remove, marginTop: 4, alignSelf: "flex-end" }, "Remove"));
};
var FieldArray = function (props) {
    var _a = (0, react_form_renderer_1.useFieldApi)(props), input = _a.input, meta = _a.meta, arrayValidator = _a.arrayValidator, fields = _a.fields, defaultItem = _a.defaultItem, maxItems = _a.maxItems, minItems = _a.minItems, rest = __rest(_a, ["input", "meta", "arrayValidator", "fields", "defaultItem", "maxItems", "minItems"]);
    return react_1.default.createElement("div", null,
        react_1.default.createElement(field_array_1.default, { key: input.name, input: input, meta: meta, name: input.name, validate: arrayValidator }, function (_a) {
            var _b = _a.fields, map = _b.map, _c = _b.value, value = _c === void 0 ? [] : _c, push = _b.push, remove = _b.remove;
            return (react_1.default.createElement(evergreen_ui_1.Pane, { display: "flex", flexDirection: "column" },
                react_1.default.createElement(evergreen_ui_1.Pane, { display: "flex" },
                    react_1.default.createElement(evergreen_ui_1.FormField, __assign({ flex: "1" }, rest)),
                    react_1.default.createElement(evergreen_ui_1.Button, __assign({ size: "small", disabled: value.length >= maxItems }, (!(value.length >= maxItems) && { onClick: function () { return push(typeof defaultItem === 'function' ? defaultItem(value) : defaultItem); } })), "Add")),
                value.length === 0 && react_1.default.createElement(evergreen_ui_1.Pane, { textAlign: "center" }, "---"),
                map(function (name, index) { return react_1.default.createElement(FieldArrayItem, { name: name, remove: function () { return remove(index); }, fields: fields, length: value.length, minItems: minItems }); })));
        }));
};
exports.default = FieldArray;
//# sourceMappingURL=field-array.js.map